require 'fileutils'
require 'manlycraft'
require 'manlycraft/command/base'

class Manlycraft::Command::Init < Manlycraft::Command::Base
  def run
    create_user
    create_server_directory
    download_minecraft_jar
    change_permissions
  end

  def create_user(username="minecraft")
    @username = username

    if RUBY_PLATFORM.match /darwin/
      `dscl . -create /Users/#{username}`
      `dscl . -create /Users/#{username} UserShell /bin/bash`
      `dscl . -create /Users/#{username} RealName "Lucius Q. User"`
      `dscl . -create /Users/#{username} UniqueID "1010"`
      `dscl . -create /Users/#{username} PrimaryGroupID 80`
      `dscl . -create /Users/#{username} NFSHomeDirectory /Users/#{username}`
    elsif RUBY_PLATFORM.match /linux/
      `sudo adduser --system --no-create-home --home /srv/minecraft-server #{username}`
    end
  end

  def create_server_directory
    FileUtils.mkdir_p(Manlycraft::Config.server_directory)
    FileUtils.chown_R(@username, @username, Manlycraft::Config.server_directory)
  end

  def download_minecraft_jar
    `sudo -u minecraft wget -P #{Manlycraft::Config.server_directory} https://s3.amazonaws.com/MinecraftDownload/launcher/minecraft_server.jar`
  end
end
